# Room Ranger

Room Ranger ist ein fortschrittliches Tool, das entwickelt wurde, um E-Mails automatisch zu verarbeiten und relevante Informationen für Hotelbuchungen, Änderungen und Stornierungen aus diesen E-Mails in eine MySQL-Datenbank zu extrahieren. Es nutzt Node.js und ist speziell darauf ausgelegt, über die Kommandozeile bedient zu werden, was es ideal für Automatisierungen, wie z.B. die Einrichtung von Cronjobs, macht.

![Room Ranger](img/roomranger.png)

## Features

- **E-Mail Abruf**: Unterstützung von IMAP zum Abrufen von E-Mails aus spezifischen Postfächern.
- **Text Parsing**: Extrahiert Text aus E-Mails und entfernt dabei HTML oder andere nicht benötigte Inhalte.
- **Daten Extraktion**: Erkennt und extrahiert spezielle Informationen relevant für Hotelbuchungen.
- **Datenbank Integration**: Speichert und aktualisiert Buchungsinformationen in einer MySQL-Datenbank.
- **OpenAI API Integration**: Sendet spezifische Anfragen an die OpenAI API, um komplexe Datenverarbeitungsaufgaben durchzuführen.
- **Cronjob freundlich**: Einfach zu konfigurieren für wiederholte Aufgaben über Cronjobs.

## Features, die noch kommen (sollten)
- **Raumliste**: Zimmer anlegen inklusive Details über die Zimmer
- **Gästeliste**: Gäste auch anlegen und wiederverwenden in der DB
- **Relationen**: Zimmer -> Reservierung -> Mensch
- **Zimmermädchenliste**
- **App**: Zimmerstatus (sauber/schmutzig/gesperrt) verwalten
- **GUI**: Zimmerreservierung grafisch (Gantt-Style) anzeigen
- **Abrechnung**: Rechungen erstellen, buchen, PDFs

## Systemanforderungen

- Node.js
- npm
- MySQL Server
- Zugang zu einem IMAP-kompatiblen E-Mail-Server

## Installation

1. Klone das Repository oder laden Sie den Code herunter.
2. Installiere die erforderlichen npm Pakete:
   ```bash
   npm install```
3. Skript starten 
   npm start