import { checkEmails } from './emailProcessor.js';
import ImapMock from 'imap';
import pkg from '@jest/globals';  // Importiere das gesamte Paket und destrukturiere dann
const { jest } = pkg;

jest.mock('imap', () => {
    return jest.fn().mockImplementation(() => {
        return {
            once: jest.fn((event, handler) => {
                if (event === 'ready') handler();
            }),
            openBox: jest.fn((box, readOnly, callback) => callback(null, {})),
            seq: {
                fetch: jest.fn().mockReturnValue({
                    on: jest.fn((event, handler) => {
                        if (event === 'message') handler({
                            on: jest.fn((event, handler) => {
                                if (event === 'body') handler('stream');
                            })
                        });
                        if (event === 'end') handler();
                    })
                })
            },
            end: jest.fn(),
            connect: jest.fn()
        };
    });
});

describe('Email Processing', () => {
    it('should initiate IMAP connection and process emails', () => {
        const imapInstance = new ImapMock();
        checkEmails();
        expect(imapInstance.once).toHaveBeenCalledWith('ready', expect.any(Function));
    });
});
